#include <windows.h>
#include <stdio.h>

int main()
{
	int i;
	void *p, *p2;
    static void* ptr[100000];

	printf("Attempting to allocate 1000MB: ");
	p = (void*)GlobalAlloc(0, 1000*1024*1024);
	if(p) puts("success"); else puts("failure");

    printf("Press [Enter] to continue"); getchar();

	printf("Attempting to reallocate to 1001MB: ");
	p2 = (void*)GlobalReAlloc(p, 1001*1024*1024, 0);
	if(p2) puts("success"); else { p2=p; puts("failure"); }

	printf("Press [Enter] to continue"); getchar();

	printf("Attempting to reallocate to 900MB: ");
	p = (void*)GlobalReAlloc(p2, 900*1024*1024, 0);
	if(p2) puts("success"); else { p=p2; puts("failure"); }

    printf("Press [Enter] to continue"); getchar();
	
	GlobalFree(p2);
	puts("Freed memory");

	printf("Attempting to allocate/free 500MB: ");
	p = (void*)GlobalAlloc(0, 500*1024*1024);
	if(p) puts("success"); else puts("failure");
	GlobalFree(p);

	printf("Press [Enter] to continue"); getchar();

	puts("Allocating/freeing 23,552 blocks of 63k");
	for(i=0; i<23*1024; i++)
	{
		ptr[i] = (void*)GlobalAlloc(0, 63*1024);
		if(ptr[i]==NULL) { puts("Unexpected failure"); return 1; }
	}
	for(i=0; i<100000; i++) GlobalFree(ptr[i]);

	printf("Press [Enter] to continue"); getchar();

	printf("Attempting to allocate/free 500MB: ");
	p = (void*)GlobalAlloc(0, 500*1024*1024);
	if(p) puts("success"); else puts("failure");
	GlobalFree(p);

	printf("Press [Enter] to continue"); getchar();

	return 0;
}